diff --git a/libavformat/isom.h b/libavformat/isom.h
index d8b262e915..62b95b40ff 100644
--- a/libavformat/isom.h
+++ b/libavformat/isom.h
@@ -318,6 +318,7 @@ typedef struct MOVContext {
     uint32_t max_stts_delta;
     int is_still_picture_avif;
     int primary_item_id;
+    int alpha_item_id;
     int *avif_item_ids;
     int avif_item_ids_size;
     int *avif_extent_lengths;
diff --git a/libavformat/mov.c b/libavformat/mov.c
index 9df5055d4e..72b17b618d 100644
--- a/libavformat/mov.c
+++ b/libavformat/mov.c
@@ -4758,6 +4758,7 @@ static int mov_read_meta(MOVContext *c, AVIOContext *pb, MOVAtom atom)
             int ret;
             avio_seek(pb, -8, SEEK_CUR);
             atom.size += 8;
+            c->alpha_item_id = -1;
             ret = mov_read_default(c, pb, atom);
             if (ret < 0)
                 return ret;
@@ -4767,6 +4768,12 @@ static int mov_read_meta(MOVContext *c, AVIOContext *pb, MOVAtom atom)
                 ret = avif_add_stream(c, c->primary_item_id);
                 if (ret)
                     return ret;
+                if (c->alpha_item_id != -1) {
+                    // Add a stream for the Alpha plane.
+                    ret = avif_add_stream(c, c->alpha_item_id);
+                    if (ret)
+                        return ret;
+                }
                 // For still AVIF images, the meta box contains all the
                 // necessary information that would generally be provided by the
                 // moov box. So simply mark that we have found the moov box so
@@ -7556,6 +7563,64 @@ static int mov_read_pitm(MOVContext *c, AVIOContext *pb, MOVAtom atom)
     return atom.size;
 }
 
+static int mov_read_iprp(MOVContext *c, AVIOContext *pb, MOVAtom atom)
+{
+    int entry_count, size, version, flags;
+    int index = 0, auxC_alpha_index = -1;
+    size = avio_rb32(pb);
+    if (avio_rl32(pb) != MKTAG('i','p','c','o'))
+        return AVERROR_INVALIDDATA;
+    size -= 8;
+    while (size > 0) {
+        int sub_size, sub_type;
+        sub_size = avio_rb32(pb);
+        sub_type = avio_rl32(pb);
+        sub_size -= 8;
+        size -= sub_size + 8;
+        index++;
+        if (sub_type == MKTAG('a','u','x','C')) {
+            const char *expected_alpha_urn = "urn:mpeg:mpegB:cicp:systems:auxiliary:alpha";
+            avio_rb32(pb);  // version & flags.
+            sub_size -= 4;
+            if (sub_size >= strlen(expected_alpha_urn) + 1) {
+                char alpha_urn[44];
+                avio_read(pb, alpha_urn, 44);
+                sub_size -= 44;
+                if (!strncmp(alpha_urn, expected_alpha_urn, 44)) {
+                    auxC_alpha_index = index;
+                }
+            }
+        }
+        avio_skip(pb, sub_size);
+    }
+    if (auxC_alpha_index == -1)
+        return atom.size;
+
+    // ipma.
+    size = avio_rb32(pb);
+    if (avio_rl32(pb) != MKTAG('i','p','m','a'))
+        return AVERROR_INVALIDDATA;
+    version = avio_r8(pb);
+    flags = avio_rb24(pb);
+    entry_count = avio_rb32(pb);
+    for (int i = 0; i < entry_count; i++) {
+        int item_id, association_count;
+        item_id = (version < 1) ? avio_rb16(pb) : avio_rb32(pb);
+        association_count = avio_r8(pb);
+        for (int j = 0; j < association_count; j++) {
+            int property_index;
+            if (flags & 1)
+                property_index = avio_rb16(pb) & 0x7fff;
+            else
+                property_index = avio_r8(pb) & 0x7f;
+            if (property_index == auxC_alpha_index) {
+                c->alpha_item_id = item_id;
+            }
+        }
+    }
+    return atom.size;
+}
+
 static int mov_read_iloc(MOVContext *c, AVIOContext *pb, MOVAtom atom)
 {
     int version, offset_size, length_size, base_offset_size, index_size;
@@ -7732,6 +7797,7 @@ static const MOVParseTableEntry mov_default_parse_table[] = {
 { MKTAG('i','l','o','c'), mov_read_iloc },
 { MKTAG('p','c','m','C'), mov_read_pcmc }, /* PCM configuration box */
 { MKTAG('p','i','t','m'), mov_read_pitm },
+{ MKTAG('i','p','r','p'), mov_read_iprp },
 { 0, NULL }
 };
 